#!/bin/sh -e

DEBUGOPTS="-DDEBUG_SSL_CLIENT"
# DEBUGOPTS=""

DELOBJ
echo Compiling helpers...
CCIX $DEBUGOPTS helpers/cert_match.c
CCIX $DEBUGOPTS -DSSL_CLIENT_ALLOW_CERT_CACHE -DSSL_CLIENT_ALLOW_AIA -I./inc helpers/cert_verify.c # for cert cache, requires -lfcrypt
CCIX $DEBUGOPTS helpers/certs_pin.c
CCIX $DEBUGOPTS helpers/http_download.c # for AIA processing in cert cache, requires -lfcl
CCIX $DEBUGOPTS helpers/conn_open.c
CCIX $DEBUGOPTS helpers/nslookup.c
CCIX $DEBUGOPTS -DSSL_CLIENT_ALLOW_CERT_CACHE helpers/client.c
CCIX $DEBUGOPTS -DSSL_CLIENT_ALLOW_CERT_CACHE helpers/nclient.c
CCIX $DEBUGOPTS -DSSL_CLIENT_ALLOW_CERT_CACHE helpers/nclient_ssl.c
CCIX $DEBUGOPTS helpers/cert_gen.c
CCIX $DEBUGOPTS helpers/server.c
CCIX -DBUILD_REMOTE_HANDLER helpers/remote.c
CCIX extlib/sha256.c
echo Linking helpers...
LDI ../work/ssl-client-wrapper cert_match.o cert_verify.o certs_pin.o http_download.o client.o sha256.o -lsimpletcp -lfcl -lssl -lcrypto
LDI ../work/fproxy-client-wrapper cert_match.o cert_verify.o certs_pin.o http_download.o nclient.o nclient_ssl.o conn_open.o nslookup.o sha256.o -lsimpletcp -lfcl -lssl -lcrypto
LDI ../work/ssl-server-wrapper cert_gen.o server.o -lsimpletcp -lssl -lcrypto
LDI ../work/proxy_r remote.o -lsimpletcp
echo Done helpers.
DELOBJ

