/*
 * This file is part of fproxy - multipurpose http(s) proxy server
 * handle/rules.resolv.h - rules_resolv.txt parse and lookup
 * Copyright (c) 2023 firk (firk@cantconnect.ru)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The origin of this software must not be misrepresented; you must
 *    not claim that you wrote the original software.
 * 4. Altered versions in any form must be plainly marked as such, and
 *    must not be misinterpreted as being the original software.
 *
 * This software is provided by the author and contributors `as is'
 * without any express or implied warranty.
 */
#ifndef INCLUDED_FPROXY_RULES_ROUTE_H
#define INCLUDED_FPROXY_RULES_ROUTE_H

typedef struct {
  /* request */
  char const   *orig_host;
  uint16       orig_port;
  char const   *orig_url;  /* url we want to retrieve */
  char         orig_https;
  /* response */
  char         use_wrapper_connect; /* 0=disable, 1=enable */
  char         https;
  char const   *new_host_port;      /* NULL = use original value (do not free!) */
  char const   *new_host;           /* NULL = use orig_host (do not free!) */
  uint32       addr;
  uint16       port;
  char const   *resolve_domain;     /* NULL = use orig_host (do not free!) */
  char const   *new_url;            /* new URL; NULL=use orig_url; if not NULL it should be free'd */
  char const   *wrapper;            /* (do not free!) */
  struct proxy_desc const *proxy;
} t_route_settings;

extern void route_rules_load(void);
extern int do_route(t_route_settings *rs);

#endif
